/*  --------------------------------------------------- !
! The current OpenMP code is to:                        !
! (1) demonstrates parallel loops.                      !
! (2) see how a loop index maps to a thread.            !
!-------------------------------------------------------!
! Xiaoxu Guan at LSU HPC.                               !
! March 08, 2017                                        !
!----------------------------------------------------- */

#include <omp.h>
#include <stdio.h>
#include <stdlib.h>

int main () {

   int i,id,nothread;
   const int nsize = 10;


// loop 1.
   printf("loop 1:\n");
#pragma omp parallel for 
  for(i = 0; i < nsize; ++i) 
   { printf("id = %d  i = %d\n", omp_get_thread_num(), i); }


// loop 2.
   printf("\nloop 2:\n");
#pragma omp parallel 
#pragma omp for 
  for(i = 0; i < nsize; ++i) 
   { printf("id = %d  i = %d\n", omp_get_thread_num(), i); }


}
