!-----------------------------------------------------------!
! The current OpenMP code is to:                            !
! (1) define a simple parallel region.                      !
! (2) demonstrate a private variable.                       !
! (3) get each thread ID.                                   !
! (4) detect the number of available processors (cores).    !
! (5) get the number of the threads.                        !
! (6) show the behaviors of Intel, PGI, and GCC.            !
!-----------------------------------------------------------!
! Xiaoxu Guan at LSU HPC.                                   !
! May 10, 2017                                              !
!-----------------------------------------------------------!

      program hello_world
      implicit none
      integer ::  id,nothread,noprocs,   &
                  omp_get_thread_num,omp_get_num_procs,omp_get_num_threads

!$omp parallel
      id = omp_get_thread_num()
      nothread = omp_get_num_threads()
      noprocs = omp_get_num_procs()
      write(*,'(1x,a,i3,2x,i3,2x,i3)') "Hello World! from ", id, nothread, noprocs
!$omp end parallel

      end program hello_world
