!=======================================================!
! The current OpenMP code is to:                        !
! (1) demonstrates parallel loops.                      !
! (2) see how a loop index maps to a thread.            !
!-------------------------------------------------------!
! Xiaoxu Guan at LSU HPC.                               !
! March 08, 2017                                        !
!=======================================================!

      program loops_f
      implicit none
      integer i,id,nothread
      integer, parameter  :: nsize = 10
      integer             :: omp_get_thread_num

! loop 1.
      write(*,'(a)') "loop 1:"
!$omp parallel do
      do i = 0, nsize-1
         write(*,'(a,i3,a,i3)') "id = ", omp_get_thread_num(), " i = ", i
      end do
!$omp end parallel do


! loop 2.
      write(*,*)
      write(*,'(a)') "loop 2:"
!$omp parallel 
!$omp do
      do i = 0, nsize-1
         write(*,'(a,i3,a,i3)') "id = ", omp_get_thread_num(), " i = ", i
      end do
!$omp end do
!$omp end parallel

      end program loops_f
