/* -----------------------------------------------------!
! The current code is to:                               !
! (1) use atomic (critical) directive.                  !
! (2) sum over from 1 to nsize.                         !
! (3) precision: real DP.                               !
!-------------------------------------------------------!
! Xiaoxu Guan at LSU HPC.                               !
! April 01, 2017                                        !
!----------------------------------------------------- */

#include <omp.h>
#include <stdio.h>
#include <stdlib.h>
#define nsize 1000

int main () 
{
    int i;
    double x = 0.0, answer;

#pragma omp parallel private(i) shared(x)
    {
        #pragma omp for
          for (i = 1; i <= nsize; ++i) {
        #pragma omp atomic
    /*      #pragma omp critical   */
          x += (double) i;
            }
    }

    answer = (double) 0.5*(nsize+1)*nsize;
    printf("parallel sum is %.2f\n", x);
    printf("correct answer is %.2f\n", answer);
}

